package fr.username404.snowygui.gui.feature

import fr.username404.snowygui.gui.Renderable
import fr.username404.snowygui.utils.FontUtil
import java.time.LocalDateTime

@ButtonInfo(Category.HUD)
object Clock: ButtonImplWithHud() {
    override fun toString(): String = LocalDateTime.now().run {
        arrayOf(hour, minute, second).map {
            (it.takeIf { (it >= 10)  } ?: "0$it").toString()
        }.reduce { previous, current -> "$previous:$current"}
    }

    override val hudRenderLambda = Renderable { poseStack ->
        poseStack?.let {
            FontUtil.drawScaled(
                it, this@Clock.toString(),
                5.0, 5.0,
                0.85F, color = Colors.GOLD
            )
        }
    }
}
