package fr.username404.snowygui.fabric

import com.mojang.blaze3d.vertex.PoseStack
import fr.username404.snowygui.EventSnowy
import fr.username404.snowygui.Snowy
import fr.username404.snowygui.gui.feature.ButtonImpl
import net.fabricmc.api.ClientModInitializer
import net.fabricmc.fabric.api.client.rendering.v1.HudRenderCallback
import net.fabricmc.fabric.api.client.rendering.v1.HudRenderCallback.EVENT
import net.fabricmc.loader.api.FabricLoader
import kotlin.io.path.exists
import kotlin.io.path.isDirectory
import kotlin.io.path.listDirectoryEntries
import kotlin.io.path.pathString

class FabricInit: Snowy(), ClientModInitializer {
    override fun onInitializeClient() {
        atInit()
        EVENT.register(
            object: HudRenderCallback, EventSnowy {
                override val type: String = "HudRender"
                override fun onHudRender(matrixStack: PoseStack?, tickDelta: Float) = fire(matrixStack)
            }
        )
    }
    override val annotatedButtons = FabricLoader.getInstance().allMods.map {
        it.getPath(FeaturePackage.replace('.', '/'))
    }.filter { it.exists() && it.isDirectory() }.flatMap { buttonsDirectory ->
        mutableSetOf<Class<out ButtonImpl>>().apply {
            buttonsDirectory.listDirectoryEntries("*.class").forEach { file ->
                @Suppress("DEPRECATION") net.fabricmc.loader.launch.common.
                FabricLauncherBase.getClass(file.pathString.drop(1).replace('/', '.').removeSuffix(".class")).let { foundClass ->
                    if (foundClass.isValidForButtonCollection()) add(foundClass.asSubclass(ButtonImpl::class.java))
                }
            }
        }
    }.toSet()
}